#define STB_IMAGE_RESIZE_IMPLEMENTATION
#define STB_IMAGE_IMPLEMENTATION

#include "stb_image.h"
#include "stb_image_resize2.h"

#define CHANNELS 2

int main() {
  int w, h, ch;
  uint8_t *image_data = stbi_load("test_image.jpg", &w, &h, &ch, CHANNELS);

  uint8_t *current_resized_data = image_data;
  int current_width = w, current_height = h;

  // Continuously resize image to half size until it reaches size 1
  while (current_width > 1 && current_height > 1) {
    uint8_t *resized_data =
        malloc(((current_width * current_height) / 2) * CHANNELS);

    stbir_resize(current_resized_data, current_width, current_height, 0,
                 resized_data, current_width / 2, current_height / 2, 0,
                 STBIR_2CHANNEL, STBIR_TYPE_UINT8, STBIR_EDGE_WRAP,
                 STBIR_FILTER_DEFAULT);

    free(current_resized_data);
    current_resized_data = resized_data;
    current_width /= 2;
    current_height /= 2;
  }

  free(current_resized_data);
}